#!/usr/bin/env python
"""
@Contact :   liuyuqi.gov@msn.cn
@Time    :   2024/03/21 12:29:53
@License :   Copyright © 2017-2022 liuyuqi. All Rights Reserved.
@Desc    :   api v1
"""

from app.api import home
from app.api.v1 import items, login, users, utils #, image_inference
from app.config import settings

from fastapi import APIRouter

api_router = APIRouter()

api_router.include_router(home.router, tags=["home"])

api_router.include_router(login.router, tags=["login"], prefix=settings.API_V1_STR)
api_router.include_router(
    users.router, prefix=settings.API_V1_STR + "/users", tags=["users"]
)
api_router.include_router(
    utils.router, prefix=settings.API_V1_STR + "/utils", tags=["utils"]
)
api_router.include_router(
    items.router, prefix=settings.API_V1_STR + "/items", tags=["items"]
)
# api_router.include_router(
#     image_inference.router, prefix=settings.API_V1_STR +"/image", tags=["image"]
# )