import codecs
import os

from setuptools import find_packages, setup

here = os.path.abspath(os.path.dirname(__file__))

with codecs.open(os.path.join(here, "README.md"), encoding="utf-8") as f:
    long_description = "\n" + f.read()
with open("requirements.txt") as f:
    install_requires = f.read().splitlines()

version = ""

setup(
    name="fastapi-example",
    version="1.0.1",
    author="liuyuqi.gov@msn.cn",
    description="fastapi example",
    long_description=long_description,
    long_description_content_type="text/markdown",
    packages=find_packages(),
    package_data={"data": ["*.txt", "*.rst", "*.md"]},
    include_package_data=True,
    install_requires=install_requires,
    zip_safe=False,
    entry_points={
        "console_scripts": ["run=apps:run"],
    },
    url="",
    project_urls={},
    keywords=[
        "fastapi",
    ],
    classifiers=[
        "Development Status :: 1 - Planning",
    ],
)
